<?php

namespace Ulmus\QueryBuilder;

use Ulmus\Query\QueryFragmentInterface;

interface QueryBuilderInterface
{
    public function push(QueryFragmentInterface $queryFragment) : self;
    public function pull(QueryFragmentInterface $queryFragment) : self;
    public function render(bool $skipToken = false) /* mixed */;
    public function reset() : void;
    public function getFragment(string $class, int $index = 0) : ? QueryFragmentInterface;
    public function removeFragment(QueryFragmentInterface|array|\Stringable|string $fragment) : void;
}