<?php

namespace Ulmus\Repository;

use Ulmus\{ConnectionAdapter, MysqlQueryBuilder, Repository, Query, Ulmus, Entity};

class SqliteRepository extends Repository {

    public function pragma(\Stringable|string $pragma, $argument = null, bool $callable = false) : self
    {
        $this->queryBuilder->pragma($pragma, $argument, $callable);

        return $this;
    }

    protected function finalizeQuery() : void
    {

    }

    public function listColumns(? string $table = null)
    {
        $table ??= $this->entityResolver->tableName();
        $this->showColumnsSqlQuery($table);

        return $this->collectionFromQuery(Entity\Sqlite\Column::class)->iterate(fn($e) => $e->tableName = $table);
    }


    protected function serverRequestCountRepository() : Repository
    {
        return new static($this->entityClass, $this->alias, $this->adapter);
    }
}
